core/urls.py
from django.urls import path
from . import views
from django.contrib.auth import views as auth_views
from .forms import LoginForm

app_name = 'core'

urlpatterns = [
    path('', views.index, name='index'),  # Home page
    path('signup/', views.signup, name='signup'),  # User signup
    path('rate/<int:video_id>/', views.rate_private_video, name='rate_private_video'),  # Rate a private video
    path('rate_public/<int:video_id>/', views.rate_public_video, name='rate_public_video'),  # Rate a public video
    path('login/', auth_views.LoginView.as_view(template_name='core/login.html', authentication_form=LoginForm), name='login'),  # User login
    path('logout/', views.logout_view, name='logout'),  # User logout
    path('generate_video/', views.generate_video, name='generate_video'),  # Generate a video
    path('toggle_visibility/<int:video_id>/', views.toggle_visibility, name='toggle_visibility'),  # Toggle video visibility
    path('public_videos/', views.public_videos, name='public_videos'),  # List of public videos
    path('delete_video/<int:video_id>/', views.delete_video, name='delete_video'),  # Delete a video
]

deepfake-evaluator/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include('core.urls')),
    path('admin/', admin.site.urls),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

core/models.py
from django.db import models
from django.core.exceptions import ValidationError
from django.contrib.auth.models import User

class MediaUpload(models.Model):
    CATEGORY_CHOICES = [
        ('wav2lip', 'Wav2Lip'),
        ('sadtalker', 'SadTalker'),
        ('makeittalk', 'MakeItTalk'),
    ]

    category = models.CharField(max_length=50, choices=CATEGORY_CHOICES, default='wav2lip')
    audio = models.FileField(upload_to='audio/', blank=True, null=True)
    video = models.FileField(upload_to='videos/', blank=True, null=True)
    image = models.ImageField(upload_to='images/', blank=True, null=True)
    uploaded_at = models.DateTimeField(auto_now_add=True)
    created_by = models.ForeignKey(User, on_delete=models.CASCADE, default=1)
    public = models.BooleanField(default=False)

    def save(self, *args, **kwargs):
        self.clean()
        super().save(*args, **kwargs)


class Rating(models.Model):
    video = models.ForeignKey(MediaUpload, related_name='ratings', on_delete=models.CASCADE)
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    facial_inconsistencies = models.FloatField(default=1)
    glitches_or_artifacts = models.FloatField(default=1)
    background_quality = models.FloatField(default=1)
    lip_sync_accuracy = models.FloatField(default=1)
    overall_score = models.FloatField(default=1, blank=True)
    created_at = models.DateTimeField(auto_now_add=True)
    is_public = models.BooleanField(default=False)

    class Meta:
        unique_together = ('video', 'user', 'is_public')

    def __str__(self):
        return f"{self.overall_score} for {self.video} by {self.user}"

core/forms.py
from django import forms 
from django.contrib.auth.forms import UserCreationForm, AuthenticationForm
from django.contrib.auth.models import User
from django.core.exceptions import ValidationError

from core.models import MediaUpload, Rating

class LoginForm(AuthenticationForm):
    username = forms.CharField(widget=forms.TextInput(attrs={
        'placeholder':'Enter your username',
        'class':'w-full py-4 px-6 dark:text-black rounded-xl'
    }))   
    password = forms.CharField(widget=forms.PasswordInput(attrs={
        'placeholder':'Enter your password',
        'class':'w-full py-4 px-6 dark:text-black rounded-xl'
    }))
    
class SignupForm(UserCreationForm):
    class Meta:
        model = User
        fields = ('username','email','password1','password2')

    username = forms.CharField(widget=forms.TextInput(attrs={
        'placeholder':'Enter your username',
        'class':'w-full py-4 px-6   dark:text-black rounded-xl'
    }))
    email = forms.CharField(widget=forms.EmailInput(attrs={
        'placeholder':'Enter your email',
        'class':'w-full py-4 px-6   dark:text-black rounded-xl'
    }))
    password1 = forms.CharField(widget=forms.PasswordInput(attrs={
        'placeholder':'Enter your password',
        'class':'w-full py-4 px-6  dark:text-black  rounded-xl'
    }))
    password2 = forms.CharField(widget=forms.PasswordInput(attrs={
        'placeholder':'Check your password',
        'class':'w-full py-4 px-6   dark:text-black rounded-xl'
    }))

from django import forms
from django.core.exceptions import ValidationError
from .models import MediaUpload, Rating

class MediaUploadForm(forms.ModelForm):
    class Meta:
        model = MediaUpload
        fields = ['category', 'audio', 'video', 'image']
        widgets = {
            'category': forms.Select(attrs={'class': 'form-control', 'style': 'color: black;'}),
        }

    def __init__(self, *args, **kwargs):
        super(MediaUploadForm, self).__init__(*args, **kwargs)
        self.fields['category'].initial = 'wav2lip'

    def clean(self):
        cleaned_data = super().clean()
        audio = cleaned_data.get('audio')
        video = cleaned_data.get('video')
        image = cleaned_data.get('image')
        category = cleaned_data.get('category')

        if category == 'makeittalk' and not image:
            raise ValidationError('You must upload an image for MakeItTalk.')

        if category != 'makeittalk' and not video:
            raise ValidationError('You must upload a video for Wav2Lip and SadTalker.')

        if audio:
            valid_audio_extensions = ['.wav', '.mp3', '.ogg', '.flac']
            if not any(audio.name.lower().endswith(ext) for ext in valid_audio_extensions):
                raise ValidationError('Invalid audio file extension. Allowed extensions are: .wav, .mp3, .ogg, .flac')

        return cleaned_data


class RatingForm(forms.ModelForm):
    class Meta:
        model = Rating
        fields = ['facial_inconsistencies', 'glitches_or_artifacts', 'background_quality', 'lip_sync_accuracy']
        widgets = {
            'facial_inconsistencies': forms.NumberInput(attrs={'step': '0.1', 'min': '0', 'max': '5', 'style': 'color: #000000; font-size: 1.25rem;'}),
            'glitches_or_artifacts': forms.NumberInput(attrs={'step': '0.1', 'min': '0', 'max': '5', 'style': 'color: #000000; font-size: 1.25rem;'}),
            'background_quality': forms.NumberInput(attrs={'step': '0.1', 'min': '0', 'max': '5', 'style': 'color: #000000; font-size: 1.25rem;'}),
            'lip_sync_accuracy': forms.NumberInput(attrs={'step': '0.1', 'min': '0', 'max': '5', 'style': 'color: #000000; font-size: 1.25rem;'}),
        }

    def clean(self):
        cleaned_data = super().clean()
        facial_inconsistencies = cleaned_data.get('facial_inconsistencies')
        glitches_or_artifacts = cleaned_data.get('glitches_or_artifacts')
        background_quality = cleaned_data.get('background_quality')
        lip_sync_accuracy = cleaned_data.get('lip_sync_accuracy')

        if not (1 <= facial_inconsistencies <= 5):
            raise forms.ValidationError("Facial inconsistencies rating must be between 1 and 5.")
        if not (1 <= glitches_or_artifacts <= 5):
            raise forms.ValidationError("Glitches or artifacts rating must be between 1 and 5.")
        if not (1 <= background_quality <= 5):
            raise forms.ValidationError("Background quality rating must be between 1 and 5.")
        if not (1 <= lip_sync_accuracy <= 5):
            raise forms.ValidationError("Lip sync accuracy rating must be between 1 and 5.")

        overall_score = (facial_inconsistencies + glitches_or_artifacts + background_quality + lip_sync_accuracy) / 4
        cleaned_data['overall_score'] = overall_score

        return cleaned_data

core/views.py
import os   
import subprocess
import shutil
from django.shortcuts import render, redirect, get_object_or_404   
from django.contrib.auth.decorators import login_required  
from django.db.models import Avg, Q, F  
from .models import MediaUpload, Rating 
from .forms import MediaUploadForm, RatingForm, SignupForm 
from django.contrib.auth import logout, login 
from django.conf import settings 

@login_required  
def generate_video(request):
    if request.method == 'POST':   
        form = MediaUploadForm(request.POST, request.FILES)  
        if form.is_valid():
            media = form.save(commit=False)  # Saving form data to media object without committing to DB

            # Setting creator of the media
            media.created_by = request.user

            # Handling specific cases based on media category
            if media.category == 'sadtalker' and 'video' in request.FILES:
                media.image = request.FILES['video']
                media.video = None

            media.save()   

            # Obtaining paths for uploaded files
            video_path = os.path.join(settings.MEDIA_ROOT, media.video.name) if media.video else None
            audio_path = os.path.join(settings.MEDIA_ROOT, media.audio.name) if media.audio else None
            image_path = os.path.join(settings.MEDIA_ROOT, media.image.name) if media.image else None

            original_dir = os.getcwd()  # Saving current working directory

            try:
                # Handling video generation based on category
                if media.category == 'wav2lip':
                    # Checking required paths for wav2lip
                    if not video_path or not audio_path:
                        raise ValueError("Video path and audio path must be provided for wav2lip.")

                    result_path = os.path.join('wav2lip', 'results', 'result_voice.mp4')

                    # Running subprocess command for wav2lip
                    command = [
                        'python', 'wav2lip/inference.py',
                        '--checkpoint_path', 'wav2lip/checkpoints/wav2lip_gan.pth',
                        '--face', video_path,
                        '--audio', audio_path,
                        '--outfile', result_path
                    ]
                    subprocess.run(command, check=True)  # Executing command and checking for errors

                    # Creating directory for user's generated videos
                    user_folder = os.path.join(settings.MEDIA_ROOT, 'generated_videos', request.user.username)
                    os.makedirs(user_folder, exist_ok=True)

                    # Copying generated video to user's directory
                    generated_video_name = f"generated_{media.id}_result_voice.mp4"
                    generated_video_media_path = os.path.join(user_folder, generated_video_name)
                    shutil.copy(result_path, generated_video_media_path)

                    # Updating media instance with generated video path
                    media.video = os.path.join('generated_videos', request.user.username, generated_video_name)
                    media.save()

                elif media.category == 'sadtalker':
                    # Checking required paths for sadtalker
                    if not audio_path or not image_path:
                        print("Audio or image path not found:")
                        print(f"audio_path: {audio_path}")
                        print(f"image_path: {image_path}")
                        raise ValueError("Audio path and image path must be provided for sadtalker.")

                    os.chdir('SadTalker-main')  # Changing directory to SadTalker's main directory

                    # Setting up command for sadtalker inference
                    command = f'''
                    source $(conda info --base)/etc/profile.d/conda.sh && \
                    conda activate sadtalker && \
                    python inference.py --driven_audio {audio_path} --source_image {image_path} --enhancer gfpgan && \
                    conda deactivate
                    '''
                    subprocess.run(command, shell=True, check=True, executable='/bin/bash')  # Running command

                    result_dir = os.path.join('results')
                    result_files = os.listdir(result_dir)
                    result_files.sort(key=lambda x: os.path.getmtime(os.path.join(result_dir, x)), reverse=True)
                    result_file = result_files[0] if result_files else None

                    if result_file:
                        result_path = os.path.join(result_dir, result_file)
                        
                        # Creating directory for user's generated videos
                        user_folder = os.path.join(settings.MEDIA_ROOT, 'generated_videos', request.user.username)
                        os.makedirs(user_folder, exist_ok=True)

                        # Copying generated video to user's directory
                        generated_video_name = f"generated_{media.id}_result_video.mp4"
                        generated_video_media_path = os.path.join(user_folder, generated_video_name)
                        shutil.copy(result_path, generated_video_media_path)

                        # Updating media instance with generated video path
                        media.video = os.path.join('generated_videos', request.user.username, generated_video_name)
                        media.save()

                    os.chdir(original_dir)  # Returning to original directory after operation

                elif media.category == 'makeittalk':
                    # Setting up paths for makeittalk
                    makeittalk_dir = os.path.join('MakeItTalk-main', 'examples')
                    audio_target_path = os.path.join(makeittalk_dir, os.path.basename(media.audio.name)) if media.audio else None
                    image_target_path = os.path.join(makeittalk_dir, os.path.basename(media.image.name)) if media.image else None

                    # Checking required paths for makeittalk
                    if not audio_target_path or not image_target_path:
                        raise ValueError("Audio path and image path must be provided for makeittalk.")
                    
                    # Copying uploaded files to makeittalk directory
                    if media.audio:
                        shutil.copy(media.audio.path, audio_target_path)
                    if media.image:
                        shutil.copy(media.image.path, image_target_path)

                    os.chdir('MakeItTalk-main')  # Changing directory to MakeItTalk's main directory

                    # Setting up command for makeittalk
                    command = [
                        'python', 'main_end2end.py',
                        '--jpg', os.path.basename(image_target_path)
                    ]
                    subprocess.run(command, check=True)  # Running command

                    result_dir = os.path.join('examples')
                    result_files = os.listdir(result_dir)
                    result_files.sort(key=lambda x: os.path.getmtime(os.path.join(result_dir, x)), reverse=True)
                    result_file = None

                    # Finding generated result file in examples folder
                    for file in result_files:
                        if file.startswith(os.path.splitext(os.path.basename(image_target_path))[0] + "_pred"):
                            result_file = file
                            break

                    if result_file:
                        result_path = os.path.join(result_dir, result_file)
                        
                        # Creating directory for user's generated videos
                        user_folder = os.path.join(settings.MEDIA_ROOT, 'generated_videos', request.user.username)
                        os.makedirs(user_folder, exist_ok=True)

                        # Copying generated video to user's directory
                        generated_video_name = f"generated_{media.id}_result_video.mp4"
                        generated_video_media_path = os.path.join(user_folder, generated_video_name)
                        shutil.copy(result_path, generated_video_media_path)

                        # Updating media instance with generated video path
                        media.video = os.path.join('generated_videos', request.user.username, generated_video_name)
                        media.save()

                    os.chdir(original_dir)  # Returning to original directory after operation

                    # Deleting unnecessary files in examples folder
                    for item in os.listdir(makeittalk_dir):
                        item_path = os.path.join(makeittalk_dir, item)
                        if os.path.isdir(item_path):
                            if item not in ['ckpt', 'dump']:
                                shutil.rmtree(item_path)
                        else:
                            os.remove(item_path)

                # Removing temporary uploaded files
                if video_path and os.path.exists(video_path):
                    os.remove(video_path)
                if audio_path and os.path.exists(audio_path):
                    os.remove(audio_path)
                if image_path and os.path.exists(image_path):
                    os.remove(image_path)

                return redirect('core:index') 

            except subprocess.CalledProcessError as e:
                print(f"Error during video generation: {e}")  
            except Exception as e:
                print(f"Unexpected error during video generation: {e}")   

    else:
        form = MediaUploadForm()  # Creating a blank form for GET requests

    return render(request, 'core/generate_video.html', {
        'form': form,   
    })


@login_required  
def toggle_visibility(request, video_id):

core/templates/core/base.html
{% load static %}
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="icon" href="{% static 'favicon.png' %}" type="image/x-icon">
    <link rel="stylesheet" href="{% static 'admin/css/custom.css' %}">
    <script src="https://cdn.tailwindcss.com"></script>
    <title>{% block title %}{% endblock title %} | DeepFakeVidEval</title>
    <style>
        /* Ensure the footer stays at the bottom of the page */
        body {
            display: flex;
            flex-direction: column;
            min-height: 100vh;
        }
        .content-wrapper {
            flex: 1;
        }
    </style>
</head>
<body class="dark:bg-gray-900">
    <nav class="dark:text-white py-6 px-6 w-full sm:flex flex-wrap justify-between items-center border-b border-gray-200">
        <a href="/" class="md:text-xl font-semibold text-orange-400">DeepFake Video Evaluator<span class="font-light"> | {{ request.user.username }}</span></a>
        <div class="md:flex md:space-x-6">
            {% if request.user.is_authenticated %}
                <div class="flex items-center justify-center space-x-6">
                    <a href="{% url 'core:public_videos' %}" class="px-6 py-3 text-lg font-bold bg-blue-500 text-white rounded-xl hover:bg-blue-600">Public Videos</a>
                    <a href="{% url 'core:logout' %}" class="px-6 py-3 text-lg font-bold bg-red-500 text-white rounded-xl hover:bg-red-600">Logout</a>
                </div>
            {% else %}
                <div class="flex items-center justify-center space-x-6">
                    <a href="{% url 'core:signup' %}" class="px-6 py-3 text-lg font-bold bg-teal-500 text-white rounded-xl hover:bg-teal-600">Sign up</a>
                    <a href="{% url 'core:login' %}" class="px-6 py-3 text-lg font-bold bg-orange-500 text-white rounded-xl hover:bg-orange-600">Login</a>
                </div>
            {% endif %}
        </div>
    </nav>

    <div class="content-wrapper px-6 py-6">
        {% block content %}
        {% endblock %}
    </div>

    <footer class="py-6 px-6 flex justify-between bg-gray-800 text-white mt-auto">
        <div class="w-full pr-10">
            <h3 class="mb-5 font-semibold text-gray-400">About DeepFake Video Evaluator</h3>
            <p class="text-lg text-gray-500 break-words">
                DeepFake Video Evaluator is a comprehensive platform designed for generating and evaluating audio-driven deepfake videos. It allows users to create realistic video content using advanced AI algorithms, assess the quality and authenticity of generated videos based on predefined metrics, and manage video privacy settings. Our platform aims to facilitate research and development in deepfake technology while promoting ethical considerations and responsible usage.
            </p>
        </div>
    </footer>
</body>
</html>

core/templates/core/generate_video.html
{% extends 'core/base.html' %}

{% block title %}Generate Video{% endblock title %}

{% block content %}
<div class="generate-video-container my-6 p-10 mx-auto bg-teal-100 dark:bg-teal-800 dark:text-white rounded-xl">
    <h1 class="mb-10 text-4xl text-center text-orange-400 font-bold">Generate Video</h1>

    <div class="flex items-center justify-center">
        <form method="post" action="{% url 'core:generate_video' %}" enctype="multipart/form-data" id="generate-form">
            {% csrf_token %}
            <style>
                .generate-video-container {
                    width: 80%;
                }

                .form-container {
                    display: flex;
                    flex-direction: column;
                    align-items: center;
                    width: 100%;
                }

                .form-item {
                    display: flex;
                    align-items: center;
                    margin-bottom: 15px;
                    width: 100%;
                    justify-content: space-between;
                }

                .form-item label {
                    color: whitesmoke;
                    font-size: 1.25rem;
                    width: 50%;
                    text-align: left;
                    white-space: nowrap;
                    font-weight: 700;
                }

                .form-item input, .form-item select {
                    padding: 4px;
                    width: 50%;
                    font-weight: 500;
                }

                #category {
                    text-align: left;
                }

                .error-container {
                    margin-top: 20px;
                    padding: 10px;
                    background-color: #f87171;
                    color: white;
                    border-radius: 10px;
                }

                @media (min-width: 768px) {
                    .generate-video-container {
                        width: 40%;
                    }
                }

                @media (max-width: 767px) {
                    .generate-video-container {
                        width: 100%;
                    }
                    .form-item {
                        flex-direction: column;
                        align-items: flex-start;
                    }
                    .form-item label {
                        width: 100%;
                    }
                    .form-item input, .form-item select {
                        width: 100%;
                    }
                }

                .hidden {
                    visibility: hidden;
                    height: 0;
                    margin-bottom: 0;
                }

                .visible {
                    visibility: visible;
                    height: auto;
                }
            </style>
            <div class="form-container">
                <div class="form-item" id="category">
                    <label for="id_category">Category</label>
                    {{ form.category }}
                </div>
                <div class="form-item visible" id="audio-upload">
                    <label for="id_audio">Audio</label>
                    {{ form.audio }}
                </div>
                <div class="form-item visible" id="video-upload">
                    <label for="id_video">Video or Image</label>
                    {{ form.video }}
                </div>
                <div class="form-item hidden" id="image-upload">
                    <label for="id_image">Image</label>
                    {{ form.image }}
                </div>

                {% if form.errors or form.non_field_errors %}
                    <div class="error-container">
                        {% for field in form %}
                            {{ field.errors }}
                        {% endfor %}
                        {{ form.non_field_errors }}
                    </div>
                {% endif %}
                <div class="flex justify-center mt-4 w-full">
                    <button type="submit" id="generate-button" class="py-3 px-8 w-full text-lg bg-teal-500 hover:bg-teal-600 rounded-xl text-white font-bold">Generate</button>
                </div>
                <p id="loading-text" class="text-gray-400 font-bold text-center" style="display:none;">Video is being generated, please wait...</p>
            </div>
        </form>
    </div>
</div>

<script>
    // Event listener for when the category selection changes
    document.getElementById('id_category').addEventListener('change', function () {
        var category = this.value;
        var audioUpload = document.getElementById('audio-upload');
        var videoUpload = document.getElementById('video-upload');
        var imageUpload = document.getElementById('image-upload');

        // Depending on the selected category, show or hide relevant upload fields
        if (category === 'makeittalk') {
            audioUpload.classList.add('visible');
            audioUpload.classList.remove('hidden');
            videoUpload.classList.add('hidden');
            videoUpload.classList.remove('visible');
            imageUpload.classList.add('visible');
            imageUpload.classList.remove('hidden');
        } else {
            audioUpload.classList.add('visible');
            audioUpload.classList.remove('hidden');
            videoUpload.classList.add('visible');
            videoUpload.classList.remove('hidden');
            imageUpload.classList.add('hidden');
            imageUpload.classList.remove('visible');
        }
    });

    // Event listener for form submission to handle loading indicator
    document.getElementById('generate-form').addEventListener('submit', function() {
        // Hide the generate button and display loading text
        document.getElementById('generate-button').style.display = 'none';
        document.getElementById('loading-text').style.display = 'block';
    });
</script>

{% endblock %}

core/templates/core/rate_private_video.html
{% extends 'core/base.html' %}

{% block title %}Rate Private Video{% endblock title %}

{% block content %}
<div class="rate-video-container my-6 p-10 mx-auto bg-teal-100 dark:bg-teal-800 dark:text-white rounded-xl">
    <h1 class="mb-6 text-3xl text-center text-orange-400 font-bold">Rate Video</h1>

    <div class="flex items-center justify-center flex-col">
        <div class="video-section w-full mb-10">
            <video controls class="w-full rounded-md bg-black border-2 border-orange-400" style="height: 250px;">
                <source src="{{ video.video.url }}" type="video/mp4">
                Your browser does not support the video tag.
            </video>
        </div>

        <form method="post" action="{% url 'core:rate_private_video' video.id %}" class="w-full">
            {% csrf_token %}
            <style>
                .rate-video-container {
                    width: 80%;  
                }
                .rating-container {
                    display: flex;
                    flex-direction: column;
                    align-items: center;
                }
                .rating-item {
                    display: flex;
                    align-items: center;
                    margin-bottom: 15px;
                    width: 90%;  
                    justify-content: space-between; 
                }
                .rating-item label {
                    color: whitesmoke;
                    font-size: 1.25rem;
                    width: 50%;  
                    margin-right: 70px;
                    text-align: left;
                    flex-shrink: 0; 
                    white-space: nowrap;
                    font-weight: 700; 
                }
                .rating-item input {
                    padding: 4px;
                    margin-left: 20px; 
                    width: 65px;  
                    text-align: left;
                    font-weight: 700;
                }
                .error-container {
                    margin-top: 20px;
                    padding: 10px;
                    background-color: #f87171;  
                    color: white;
                    border-radius: 10px;
                }
                @media (min-width: 768px) {
                    .rate-video-container {
                        width: 40%;
                    }
                }
                @media (max-width: 767px) {
                    .rate-video-container {
                        width: 100%;
                    }
                    .rating-item {
                        flex-direction: column; 
                        align-items: flex-start;
                    }
                    .rating-item label {
                        width: auto; 
                    }
                    .rating-item input {
                        width: 100%; 
                    }
                }
            </style>
            <div class="rating-container">
                <div class="rating-item">
                    <label for="id_facial_inconsistencies">Facial Inconsistencies</label>
                    {{ form.facial_inconsistencies }}
                </div>
                <div class="rating-item">
                    <label for="id_glitches_or_artifacts">Glitches or Artifacts</label>
                    {{ form.glitches_or_artifacts }}
                </div>
                <div class="rating-item">
                    <label for="id_background_quality">Background Quality</label>
                    {{ form.background_quality }}
                </div>
                <div class="rating-item">
                    <label for="id_lip_sync_accuracy">Lip Sync Accuracy</label>
                    {{ form.lip_sync_accuracy }}
                </div>
            </div>
    
            {% if form.errors or form.non_field_errors %}
                <div class="error-container">
                    {% for field in form %}
                        {{ field.errors }}
                    {% endfor %}
                    {{ form.non_field_errors }}
                </div>
            {% endif %}
            <div class="flex justify-center mt-4">
                <button type="submit" class="py-3 px-8 w-full text-lg bg-teal-500 hover:bg-teal-600 rounded-xl text-white font-bold">Submit Rating</button>
            </div>
        </form>
    </div>    
</div>

{% endblock %}